//simple geometry intersection functions
//Luke Lenhart (2005)
//See /docs/License.txt for details on how this code may be used.

#include "GeoIntersect.h"
#include <cmath>

//
namespace GEO
{
    //line and plane intersection
    bool LinePlane(const Line &inLine, const Plane &inPlane, Vector3 &outPoint)
    {
        //get dot between plane normal and line
        float dotPL=VecDot(inPlane.Normal(),inLine.dir);

        //if they intersect
        if (std::fabs(dotPL) > FLOAT_TOLERANCE)
        {
            //solve parametric part
            float param=-VecDot(inPlane.Normal(),inLine.pos)/dotPL;

            //scale direction of line from its base point to get intersection
            outPoint=inLine.pos + inLine.dir*param;
            return true;
        }

        //was parallel.. bad..
        return false;
    }

}; //namespace GEO
